green = pge.gfx.createcolor(0, 255, 0)
red = pge.gfx.createcolor(255, 0, 0)
blue = pge.gfx.createcolor(0, 0, 255)
cyan = pge.gfx.createcolor(0, 255, 255)
yellow = pge.gfx.createcolor(255, 255, 0)

CameraX = 0;
CameraY = 0;
CameraSpeed = 0;

function CreateBlocks(filename)
dofile(filename)
end

function CreateGround(filename)
dofile(filename)
end

function CreatePlayer(filename)
dofile(filename)
end

function CreateEnemies(filename)
dofile(filename)
end

function CreateCheckPoints(filename)
dofile(filename)
end

function CollisionCheckPlatform (object1, object2)
	return (object1.x + object1.width > object2.x) and (object1.x < object2.x + object2.width) and (object1.y + object1.height > object2.y) and (object1.y < object2.y + object2.height) 
end

function InitializeObjectJumping(object,Floor, grav)
object = player or object
Floor = Floor or 230
grav = grav or 0.35
jumping = false

	if pge.controls.pressed(PGE_CTRL_CROSS) or pge.controls.held(PGE_CTRL_CROSS) and object.falling == 0 then
		jumping = true
	elseif not pge.controls.pressed(PGE_CTRL_CROSS) and object.y < Floor or object.falling == 1 then
		jumping = true
	end
	
	if jumping then
		object.speedY = object.speedY - grav
		object.y = object.y - object.speedY
	end
	
for i = 1,table.getn(blocks) do
	if CollisionCheckPlatform(object,blocks[i]) and jumping and blocks[i].solid then
			object.speedY = 0
	if CollisionCheckPlatform(object,blocks[i]) and pge.controls.held(PGE_CTRL_CROSS) or pge.controls.pressed(PGE_CTRL_CROSS) and blocks[i].solid then
			jumping = true
			object.speedY = 10
	end
	
	if object.y < blocks[i].y and blocks[i].solid then
		object.y = blocks[i].y - object.height
	else
		object.y = blocks[i].y + blocks[i].height
		object.speedY = -0.5
	end
	if object.y == blocks[i].y + blocks[i].height and blocks[i].color == blue and blocks[i].solid then
		blocks[i].solid = not blocks[i].solid
			end
		end
	end
		
	if object.y >= Floor and object.falling == 0 then
		object.y = Floor
		object.speedY = 10
		jumping = false
	end
	
for a = 1,table.getn(enemies) do
	if CollisionCheckPlatform (object, enemies[a]) and enemies[a].solid and object.falling == 0 then
		if object.y < enemies[a].y and enemies[a].solid then
			object.y = enemies[a].y - object.height;
		else
			object.y = enemies[a].y + enemies[a].height;
			object.speedY = -1
			end
		end
	end
end

function InitializeObjectMovement(object)
object = player or object

object.x = object.x + object.speedX

	if pge.controls.pressed(PGE_CTRL_LEFT) or pge.controls.held(PGE_CTRL_LEFT) or pge.controls.analogx() < -99 then
	    if object.speedX == 0 then
			object.speedX = -2;
		end
	else
		if object.speedX == -2 then
			object.speedX = 0;
		end
	end
	
	if pge.controls.pressed(PGE_CTRL_RIGHT) or pge.controls.held(PGE_CTRL_RIGHT) or pge.controls.analogx() > 99 then
	    if object.speedX == 0 then
			object.speedX = 2;
			end
	else
	    if object.speedX == 2 then
			object.speedX = 0;
		end
	end

	for i = 1, table.getn(blocks) do	
		if CollisionCheckPlatform (object, blocks[i]) and blocks[i].solid then
			object.speedX = 0
		if object.x < blocks[i].x and blocks[i].solid then
		   object.x = blocks[i].x - object.width;
			CameraSpeed = 0;
	    else
		   object.x = blocks[i].x + blocks[i].width
			end
		end
	end
end

function UpdateCamera(object, MapWidth, MapHeight)
object = player or object
MapWidth = 6000 or MapWidth
MapHeight = 272 or MapHeight
ScreenWidth = 480;
ScreenHeight = 272;
CameraX = CameraX + CameraSpeed;

	if object.x > CameraX + 130 and object.speedX == 2 then
		CameraSpeed = 2;
	else
		CameraSpeed = 0;
	end
	-- Check if it is in bounds of the world
	if object.x < 0 then
	    object.x = 0;
	end
	if object.x > MapWidth - object.width then
	    object.x = MapWidth - object.width;
	end
	if object.y < -90 then
		object.speedY = -2;
	end	
	for c = 1,table.getn(Checkpoint) do
			if object.y > 330 then
				if Checkpoint[c].done then
					object.x = Checkpoint[c].x - object.width
					object.lives = object.lives - 1
					object.y = 230
					CameraX = Checkpoint[c].x 
				end
			end
		end
	-- Check if it is in bounds of the screen
	if object.x < CameraX then
		object.speedX = 0;
		object.x = CameraX;
	 end
		 
	 if object.y < CameraY then
		CameraY = object.y;
	 end
	if CameraX < 0 then
	    CameraX = 0;
	end
	if CameraX > (MapWidth - ScreenWidth) then
	    CameraX = MapWidth - ScreenWidth;
	end
	
	if CameraY < 0 then
	    CameraY = 0;
	end

	if CameraY > (MapHeight - ScreenHeight) then
	    CameraY = MapHeight - ScreenHeight;
	end
end

function CheckFloorAgainstObject(Object1,check, Floor)
Object1 = player or Object1
Floor = Floor or 230

	if Object1.y == Floor and Object1.x + Object1.width >= Ground[check].x and Object1.x <= Ground[check].x + Ground[check].width then
			Object1.falling = 0
			Object1.speedY = 10
	end
	if Object1.y == Floor and Object1.x > Ground[check].x + Ground[check].width then
			Object1.falling = 1	
			Object1.speedY = -3
	end
end

function ObjectWin(object, winning_block, End)
object = player or object

	if object.x == blocks[winning_block].x - object.width and blocks[winning_block].win then
		object.x = blocks[winning_block].x + blocks[winning_block].width
	end
	if object.x >= blocks[winning_block].x then
		object.speedX = 1.2
	end
	if object.x > End then
		dofile("won.lua")
	end
	if object.lives < 0 then
		dofile("die.lua")
	end
end

function CheckIfObjectHasPassedCheckpoint(object)
object = player or object 

	for c = 1,table.getn(Checkpoint) do
		if object.x + object.width >= Checkpoint[c].x and Checkpoint[c].x <= object.x + object.width then
				Checkpoint[c].done = true
		end
	if Checkpoint[1].done and object.x + object.width >= Checkpoint[2].x and Checkpoint[2].x <= object.x + object.width then
			Checkpoint[1].done = false
	elseif Checkpoint[2].done and object.x + object.width >= Checkpoint[3].x and Checkpoint[3].x <= object.x + object.width then
			Checkpoint[2].done = false
		end
	end
end

function UpdateEnemies(moving,object, Floor)
object = player or object
Floor = 230 or Floor

	if object.x + 480 > enemies[moving].x then
		enemies[moving].x = enemies[moving].x - enemies[moving].speed; -- Updates the X axis postition
		enemies[moving].y = enemies[moving].y - enemies[moving].speedY; -- Updates the Y axis postition
	end

for i = 1,table.getn(blocks) do
	if CollisionCheckPlatform(enemies[moving], blocks[i]) then
		if enemies[moving].x < blocks[i].x and blocks[i].solid and enemies[moving].solid then
		   enemies[moving].x = blocks[i].x - enemies[moving].width;
			enemies[moving].speed = 1
	    else
		   enemies[moving].x = blocks[i].x + blocks[i].width;
			enemies[moving].speed = -1
		end
	end
end

		if object.x == enemies[moving].x - object.width and object.y + object.height > enemies[moving].y and object.y < enemies[moving].y + enemies[moving].height and enemies[moving].solid then
			object.speedY = 8
			object.falling = 1
		elseif object.x == enemies[moving].x + enemies[moving].width and object.y + object.height > enemies[moving].y and object.y < enemies[moving].y + enemies[moving].height and enemies[moving].solid then
			object.speedY = 8
			object.falling = 1	
		elseif object.y == enemies[moving].y + enemies[moving].height and object.x + object.width > enemies[moving].x and object.x < enemies[moving].x + enemies[moving].width and enemies[moving].solid then
			object.falling = 1	
		elseif object.y == enemies[moving].y - object.height and object.x + object.width > enemies[moving].x and object.x < enemies[moving].x + enemies[moving].width and enemies[moving].solid and object.falling == 0 then
			object.speedY = 6
			enemies[moving].solid = false
	end
for a = 1,table.getn(Ground) do
	if enemies[moving].y == Floor and enemies[moving].x + enemies[moving].width >= Ground[a].x and enemies[moving].x <= Ground[a].x + Ground[a].width then
			enemies[moving].falling = 0
			enemies[moving].speedY = 0
	end
	if enemies[moving].y == Floor and enemies[moving].x > Ground[a].x + Ground[a].width then
			enemies[moving].falling = 1	
			enemies[moving].speedY = -3
		end
	end
end
