dofile("Core/Core.lua")
CreateGround("Data/ground/ground1.txt")
CreateBlocks("Data/levels/level1.txt")
CreateEnemies("Data/enemies/enemies1.txt")
CreatePlayer("Data/player/player1.txt")
CreateCheckPoints("Data/checkpoints/checkpoints1.txt")
verdana12 = pge.font.load("verdana.ttf", 12, PGE_RAM)

while pge.running() do
pge.controls.update()

	-- Call the functions
	InitializeObjectJumping()
	InitializeObjectMovement()
	UpdateCamera()
	for b = 1,table.getn(Ground) do
		CheckFloorAgainstObject(player, b)
	end
	CheckIfObjectHasPassedCheckpoint()
	for c = 1,table.getn(enemies) do
		UpdateEnemies(c)
	end
	ObjectWin(player, 60, 5890)

	-- Start drawing
	pge.gfx.startdrawing()
	-- Revert to drawing directly to the screen
	pge.gfx.rendertoscreen()
	-- Clear screen
	pge.gfx.clearscreen()
	
	-- Draw the block 
	for i = 1, table.getn(blocks) do
		if blocks[i].solid then
			pge.gfx.drawrect(blocks[i].x - CameraX, blocks[i].y - CameraY, blocks[i].width, blocks[i].height, blocks[i].color);
		end
	end -- end for-loop
	
	-- Draw the Ground
	for a = 1, table.getn(Ground) do
		pge.gfx.drawrect(Ground[a].x - CameraX, Ground[a].y - CameraY, Ground[a].width, Ground[a].height, green);
	end -- end for-loop
	
	-- Draw the enemies
	for b = 1,table.getn(enemies) do
		if enemies[b].solid then
			pge.gfx.drawrect(enemies[b].x - CameraX, enemies[b].y - CameraY, enemies[b].width, enemies[b].height, yellow);
		end
	end -- end for-loop
	
	-- Draw the player image 
	pge.gfx.drawrect(player.x - CameraX, player.y - CameraY, player.width, player.height, cyan);
	
	verdana12:activate();
	verdana12:print(20,10, green, "Enemie 3's Speed Y = "..enemies[3].speedY);
	verdana12:print(20,25, green, "Enemie 3's Y = "..enemies[3].y);
	verdana12:print(20,40, green, "Player X = "..player.x);
	
	-- End drawing
	pge.gfx.enddrawing()
	
	-- Swap buffers
	pge.gfx.swapbuffers()
end -- end while-loop

verdana12 = nil